C
C**********************************************************************
C*                                                                    *
C*                                                                    *
C*                                                                    *
C*             D R A W   -   C L I E N T   L I B R A R Y              *
C*                                                                    *
C*                   F O R T R A N     M O D U L E                    *
C*                                                                    *
C*                 (Main Control Graphic Directives)                  *
C*                   (fortran Adaptation Support)                     *
C*                                                                    *
C*                                                                    *
C*                               by                                   *
C*                                                                    *
C*          Pierre Wolfers, Laboratoire de Cristallographie           *
C*                                                                    *
C*          CNRS GRENOBLE,  25 Avenue des Martyrs, B.P. 166           *
C*                                                                    *
C*                     F 38042 GRENOBLE CEDEX 9                       *
C*                                                                    *
C*                           F R A N C E                              *
C*                                                                    *
C*                                                                    *
C*                                                                    *
C**********************************************************************
C
C
C
C/////////////////////////////////////////////////////////////////////////
C//                                                                     //
C//                                                                     //
C// This license described in this file overrides all other licenses    //
C// that might be specified in other files for this library.            //
C//                                                                     //
C// This library is free software; you can redistribute it and/or       //
C// modify it under the terms of the GNU Lesser General Public          //
C// License as published by the Free Software Foundation; either        //
C// version 2.1 of the License, or (at your option) any later version.  //
C//                                                                     //
C// This library is distributed in the hope that it will be useful,     //
C// but WITHOUT ANY WARRANTY; without even the implied warranty of      //
C// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU   //
C// Library General Public License for more details.                    //
C//                                                                     //
C// You should have received a copy of the GNU Lesser General Public    //
C// License along with this library (see COPYING.LIB); if not, write to //
C// the Free Software Foundation :                                      //
C//                      Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  //
C//                                                                     //
C/////////////////////////////////////////////////////////////////////////
C
C
	SUBROUTINE DRAW_INIT( XP, YP, UNIT, PRGNAM )
	IMPLICIT NONE
	REAL          XP, YP
	INTEGER       UNIT, L
	CHARACTER*(*) PRGNAM

	EXTERNAL DRAW__INIT

C	COMMON /STR/ STR, SRE, STB
C	CHARACTER*1 STR(255), SRE(255), STB(1024)

	INTEGER  I

C	L = LEN( PRGNAM )

C	IF (L.GT.0) THEN
C	  DO I = 1, L
C	    STR(I) = PRGNAM(I:I)
C	  END DO
C	ENDIF

C	CALL DRAW__INIT( XP, YP, UNIT, STR, L )

	CALL DRAW__INIT( XP, YP, UNIT, PRGNAM, LEN( PRGNAM ) )

	RETURN
	END
C
C================================================================================
C
	LOGICAL FUNCTION DRAW_PICTURE3( TITLE, X, Y, Z, SCALE, MARGIN )
	IMPLICIT NONE
	CHARACTER*(*) TITLE
	REAL          X, Y, Z
	LOGICAL*1     SCALE, MARGIN

	EXTERNAL DRAW__PICTURE
	LOGICAL  DRAW__PICTURE

	DRAW_PICTURE3 = DRAW__PICTURE( TITLE, LEN( TITLE ),
     &                               X, Y, Z, SCALE, MARGIN )

	RETURN
	END
C
C================================================================================
C
	LOGICAL FUNCTION DRAW_PICTURE( TITLE, X, Y, SCALE, MARGIN )
	IMPLICIT NONE
	CHARACTER*(*) TITLE
	REAL          X, Y
	LOGICAL*1     SCALE, MARGIN

C	COMMON /STR/ STR, SRE, STB
C	CHARACTER*1 STR(255), SRE(255), STB(1024)

C	INTEGER      I, L

	EXTERNAL DRAW__PICTURE
	LOGICAL  DRAW__PICTURE

C	L = LEN( TITLE )
C	IF (L.GT.0) THEN
C	  DO I = 1, L
C	    STR(I) = TITLE(I:I)
C	  END DO
C	ENDIF

	DRAW_PICTURE = DRAW__PICTURE( TITLE, LEN( TITLE ),
     &                              X, Y, 0.0, SCALE, MARGIN )

	RETURN
	END
C
C================================================================================
C
	SUBROUTINE DRAW_STRING( X, Y, THETA, HGT, STRG )
	IMPLICIT NONE
	REAL          X, Y, THETA, HGT
	CHARACTER*(*) STRG

C	COMMON /STR/ STR, SRE, STB
C	CHARACTER*1 STR(255), SRE(255), STB(1024)

C	INTEGER       I, L

	EXTERNAL DRAW__STRING

C	L = LEN( STRG )
C	IF (L.GT.0) THEN
C	  DO I = 1, L
C	    STR(I) = STRG(I:I)
C	  END DO
C	ENDIF

	CALL DRAW__STRING( X, Y, THETA, HGT, STRG, LEN( STRG ), 0 )
	RETURN

	END

C
C================================================================================
C
