//	VGLdrw_cmdw.h:	Header for VGL_Draw_Servercmdw class
//=======================================================================

#ifndef VGL_Draw_ServerCMDW_H
#define VGL_Draw_ServerCMDW_H


#include <v/vcmdwin.h>	// So we can use vCmdWindow
#include <v/vmenu.h>	// For the menu pane#include <v/vstatusp.h>	// For the status pane
#include <v/vstatusp.h>	// For the status pane
#include <v/vutil.h>	// For V Utilities
#include <v/vtimer.h>   // Timer
#include <v/vmodald.h>  // Modal Dialog


#ifdef vDEBUG
#include <v/vdebug.h>
#endif

#include <draw/sdrw_env.h> // Get Draw_Server Env.


#include "VGLdrw_cnv.h"	// VGL_Draw_ServerOGLCanvasPane
// #include "VGLdrw_dlg.h"	// VGL_Draw_ServerDialog


    class VGL_Draw_ServerCmdWindow;

    class VGL_Draw_ServerAuxTimer : public vTimer
      {
      public:		//---------------------------------------- public
	VGL_Draw_ServerAuxTimer(VGL_Draw_ServerCmdWindow* cw) { cmdw = cw; }
	~VGL_Draw_ServerAuxTimer() {}
	virtual void TimerTick();
      private:		//--------------------------------------- private
	VGL_Draw_ServerCmdWindow* cmdw;
      };

    class VGL_Draw_Dialog : public vModalDialog
      {
      public:		//--------------------------------------- public
	VGL_Draw_Dialog( vBaseWindow* bw, char* title = "" ) :
	 vModalDialog( bw, title ) {}
	virtual ~VGL_Draw_Dialog() {}  // Destructor
        virtual void DialogDisplayed();
	virtual void DialogCommand( ItemVal, ItemVal, CmdType );
	void AddDefaultCmds();       // to add the defined commands

      protected:	//--------------------------------------- protected

      private:		//--------------------------------------- private
      };

    class VGL_Draw_ServerCmdWindow : public vCmdWindow
      {
        friend int AppMain(int, char**);	// allow AppMain access
        friend class VGL_Draw_ServerAuxTimer;
        friend class VGL_Draw_Dialog;
        // VGL_Draw_ServerGLTimer

      public:		//---------------------------------------- public
        VGL_Draw_ServerCmdWindow(char*, int, int);
	virtual ~VGL_Draw_ServerCmdWindow();
        virtual void WindowCommand(ItemVal id, ItemVal val, CmdType cType);
        virtual void KeyIn(vKey keysym, unsigned int shift);
        virtual void SetSens( ItemVal id, int val );
        virtual void SetDialogSens( int flg );
        VGL_Draw_ServerAuxTimer* GetVGL_Draw_ServerAuxTimer() {return _auxTimer;}// Aux Timer

      protected:	//--------------------------------------- protected

      private:		//--------------------------------------- private

        // Standard elements
	vMenuPane* VGL_Draw_ServerMenu;      // For the menu bar
	VGL_Draw_ServerOGLCanvasPane* VGL_Draw_ServerCanvas; // For the canvas
	vStatusPane* VGL_Draw_ServerStatus;  // For the status bar
	VGL_Draw_ServerAuxTimer* _auxTimer;  // Aux Timer

        // Dialogs associated with CmdWindow

        VGL_Draw_Dialog* V_User_Menu;
        VGL_Draw_Dialog* V_User_Value;

      };

#endif
